/***********************************************************************************************************************
 *
 * blueMarine Semantic - open source media workflow
 * Copyright (C) 2008-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~semantic-src
 *
 **********************************************************************************************************************/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic.node.impl;

import java.util.Iterator;
import java.util.SortedSet;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author fritz
 */
public class NameSpaceSegmenterTest 
  {
    private NameSpaceSegmenter fixture;

    @Before
    public void setUp() 
      {
        fixture = new NameSpaceSegmenter();
      }

    @Test
    public void common()
      {
        assertEquals("abc/", NameSpaceSegmenter.common("abc/de", "abc/"));
        assertEquals("", NameSpaceSegmenter.common("abc/de", "abcfg"));
        assertEquals("", NameSpaceSegmenter.common("abcde", "bcde"));
        assertEquals("abc#", NameSpaceSegmenter.common("abc#de", "abc#d"));
        assertEquals("abc/", NameSpaceSegmenter.common("abc/de", "abc/d"));
      }

    @Test
    public void test()
      {
        fixture.add("http://www.daml.org/2001/01/gedcom/gedcom#Birth");
        fixture.add("http://www.daml.org/2001/01/gedcom/gedcom#Death");
        fixture.add("http://www.daml.org/2001/01/gedcom/gedcom#Divorce");
        fixture.add("http://www.daml.org/2001/01/gedcom/gedcom#Family");
        fixture.add("http://www.daml.org/2001/01/gedcom/gedcom#Individual");
        fixture.add("http://www.daml.org/2001/01/gedcom/gedcom#Marriage");

        fixture.add("http://www.example.com/foo");
        fixture.add("http://www.example.com/bar");

        fixture.add("http://www.example2.com/foo#aa");
        fixture.add("http://www.example2.com/foo#ab");

        final SortedSet<String> nameSpaces = fixture.getNameSpaces();
          System.err.println("RESULT " + nameSpaces);
        assertEquals(3, nameSpaces.size());
        final Iterator<String> i = nameSpaces.iterator();
        assertEquals("http://www.daml.org/2001/01/gedcom/gedcom#", i.next());
        assertEquals("http://www.example.com/", i.next());
        assertEquals("http://www.example2.com/foo#", i.next());
      }
  }